summaryrefslogtreecommitdiff
path: root/lib
diff options
context:
space:
mode:
Diffstat (limited to 'lib')
-rw-r--r--lib/aliases.zsh2
-rw-r--r--lib/completion.zsh3
-rw-r--r--lib/directories.zsh6
-rw-r--r--lib/functions.zsh59
-rw-r--r--lib/git.zsh28
-rw-r--r--lib/key-bindings.zsh7
-rw-r--r--lib/termsupport.zsh50
-rw-r--r--lib/theme-and-appearance.zsh (renamed from lib/appearance.zsh)2
8 files changed, 102 insertions, 55 deletions
diff --git a/lib/aliases.zsh b/lib/aliases.zsh
index d2d3aed81..b47de5bde 100644
--- a/lib/aliases.zsh
+++ b/lib/aliases.zsh
@@ -21,3 +21,5 @@ alias ll='ls -l'
alias sl=ls # often screw this up
alias afind='ack-grep -il'
+
+alias x=extract
diff --git a/lib/completion.zsh b/lib/completion.zsh
index 9c2dfecca..fdd0a8536 100644
--- a/lib/completion.zsh
+++ b/lib/completion.zsh
@@ -8,9 +8,6 @@ setopt always_to_end
WORDCHARS=''
-autoload -U compinit
-compinit -i
-
zmodload -i zsh/complist
## case-insensitive (all),partial-word and then substring completion
diff --git a/lib/directories.zsh b/lib/directories.zsh
index 56d7a2316..bb114f615 100644
--- a/lib/directories.zsh
+++ b/lib/directories.zsh
@@ -36,5 +36,9 @@ cd () {
alias md='mkdir -p'
alias rd=rmdir
+alias d='dirs -v'
-alias d='dirs -v' \ No newline at end of file
+# mkdir & cd to it
+function mcd() {
+ mkdir -p "$1" && cd "$1";
+} \ No newline at end of file
diff --git a/lib/functions.zsh b/lib/functions.zsh
index e3c0de43e..b29d3e482 100644
--- a/lib/functions.zsh
+++ b/lib/functions.zsh
@@ -1,26 +1,3 @@
-## fixme, i duplicated this in xterms - oops
-function title {
- if [[ $TERM == "screen" ]]; then
- # Use these two for GNU Screen:
- print -nR $'\033k'$1$'\033'\\\
-
- print -nR $'\033]0;'$2$'\a'
- elif [[ ($TERM =~ "^xterm") ]] || [[ ($TERM == "rxvt") ]]; then
- # Use this one instead for XTerms:
- print -nR $'\033]0;'$*$'\a'
- fi
-}
-
-function precmd {
- title zsh "$PWD"
-}
-
-function preexec {
- emulate -L zsh
- local -a cmd; cmd=(${(z)1})
- title $cmd[1]:t "$cmd[2,-1]"
-}
-
function zsh_stats() {
history | awk '{print $2}' | sort | uniq -c | sort -rn | head
}
@@ -37,3 +14,39 @@ function take() {
mkdir -p $1
cd $1
}
+
+function extract() {
+ unset REMOVE_ARCHIVE
+
+ if test "$1" = "-r"; then
+ REMOVE=1
+ shift
+ fi
+ if [[ -f $1 ]]; then
+ case $1 in
+ *.tar.bz2) tar xvjf $1;;
+ *.tar.gz) tar xvzf $1;;
+ *.tar.xz) tar xvJf $1;;
+ *.tar.lzma) tar --lzma -xvf $1;;
+ *.bz2) bunzip $1;;
+ *.rar) unrar x $1;;
+ *.gz) gunzip $1;;
+ *.tar) tar xvf $1;;
+ *.tbz2) tar xvjf $1;;
+ *.tgz) tar xvzf $1;;
+ *.zip) unzip $1;;
+ *.Z) uncompress $1;;
+ *.7z) 7z x $1;;
+ *) echo "'$1' cannot be extracted via >extract<";;
+ esac
+
+ if [[ $REMOVE_ARCHIVE -eq 1 ]]; then
+ echo removing "$1";
+ /bin/rm "$1";
+ fi
+
+ else
+ echo "'$1' is not a valid file"
+ fi
+}
+
diff --git a/lib/git.zsh b/lib/git.zsh
index 75fdc1f9c..ce4de5598 100644
--- a/lib/git.zsh
+++ b/lib/git.zsh
@@ -4,7 +4,8 @@ function git_prompt_info() {
echo "$ZSH_THEME_GIT_PROMPT_PREFIX${ref#refs/heads/}$(parse_git_dirty)$ZSH_THEME_GIT_PROMPT_SUFFIX"
}
-parse_git_dirty () {
+# Checks if working tree is dirty
+parse_git_dirty() {
if [[ -n $(git status -s 2> /dev/null) ]]; then
echo "$ZSH_THEME_GIT_PROMPT_DIRTY"
else
@@ -12,7 +13,24 @@ parse_git_dirty () {
fi
}
-# get the status of the working tree
+# Checks if there are commits ahead from remote
+function git_prompt_ahead() {
+ if $(echo "$(git log origin/$(current_branch)..HEAD 2> /dev/null)" | grep '^commit' &> /dev/null); then
+ echo "$ZSH_THEME_GIT_PROMPT_AHEAD"
+ fi
+}
+
+# Formats prompt string for current git commit short SHA
+function git_prompt_short_sha() {
+ SHA=$(git rev-parse --short HEAD 2> /dev/null) && echo "$ZSH_THEME_GIT_PROMPT_SHA_BEFORE$SHA$ZSH_THEME_GIT_PROMPT_SHA_AFTER"
+}
+
+# Formats prompt string for current git commit long SHA
+function git_prompt_long_sha() {
+ SHA=$(git rev-parse HEAD 2> /dev/null) && echo "$ZSH_THEME_GIT_PROMPT_SHA_BEFORE$SHA$ZSH_THEME_GIT_PROMPT_SHA_AFTER"
+}
+
+# Get the status of the working tree
git_prompt_status() {
INDEX=$(git status --porcelain 2> /dev/null)
STATUS=""
@@ -26,11 +44,15 @@ git_prompt_status() {
fi
if $(echo "$INDEX" | grep '^ M ' &> /dev/null); then
STATUS="$ZSH_THEME_GIT_PROMPT_MODIFIED$STATUS"
+ elif $(echo "$INDEX" | grep '^AM ' &> /dev/null); then
+ STATUS="$ZSH_THEME_GIT_PROMPT_MODIFIED$STATUS"
+ elif $(echo "$INDEX" | grep '^ T ' &> /dev/null); then
+ STATUS="$ZSH_THEME_GIT_PROMPT_MODIFIED$STATUS"
fi
if $(echo "$INDEX" | grep '^R ' &> /dev/null); then
STATUS="$ZSH_THEME_GIT_PROMPT_RENAMED$STATUS"
fi
- if $(echo "$INDEX" | grep '^ D ' &> /dev/null); then
+ if $(echo "$INDEX" | grep '^D ' &> /dev/null); then
STATUS="$ZSH_THEME_GIT_PROMPT_DELETED$STATUS"
fi
if $(echo "$INDEX" | grep '^UU ' &> /dev/null); then
diff --git a/lib/key-bindings.zsh b/lib/key-bindings.zsh
index 7196a88ff..9f28d5761 100644
--- a/lib/key-bindings.zsh
+++ b/lib/key-bindings.zsh
@@ -1,6 +1,4 @@
# TODO: Explain what some of this does..
-autoload -U compinit
-compinit -i
bindkey -e
bindkey '\ew' kill-region
@@ -22,6 +20,11 @@ bindkey ' ' magic-space # also do history expansion on space
bindkey '^[[Z' reverse-menu-complete
+# Make the delete key (or Fn + Delete on the Mac) work instead of outputting a ~
+bindkey "^[[3~" delete-char
+bindkey "^[3;5~" delete-char
+bindkey "\e[3~" delete-char
+
# consider emacs keybindings:
#bindkey -e ## emacs key bindings
diff --git a/lib/termsupport.zsh b/lib/termsupport.zsh
index fef978748..22e7f372f 100644
--- a/lib/termsupport.zsh
+++ b/lib/termsupport.zsh
@@ -1,21 +1,29 @@
-case "$TERM" in
- xterm*|rxvt*)
- preexec () {
- print -Pn "\e]0;%n@%m: $1\a" # xterm
- }
- precmd () {
- print -Pn "\e]0;%n@%m: %~\a" # xterm
- }
- ;;
- screen*)
- preexec () {
- local CMD=${1[(wr)^(*=*|sudo|ssh|-*)]}
- echo -ne "\ek$CMD\e\\"
- print -Pn "\e]0;%n@%m: $1\a" # xterm
- }
- precmd () {
- echo -ne "\ekzsh\e\\"
- print -Pn "\e]0;%n@%m: %~\a" # xterm
- }
- ;;
-esac \ No newline at end of file
+#usage: title short_tab_title looooooooooooooooooooooggggggg_windows_title
+#http://www.faqs.org/docs/Linux-mini/Xterm-Title.html#ss3.1
+#Fully support screen, iterm, and probably most modern xterm and rxvt
+#Limited support for Apple Terminal (Terminal can't set window or tab separately)
+function title {
+ [ "$DISABLE_AUTO_TITLE" != "true" ] || return
+ if [[ "$TERM" == screen* ]]; then
+ print -Pn "\ek$1:q\e\\" #set screen hardstatus, usually truncated at 20 chars
+ elif [[ "$TERM" == xterm* ]] || [[ $TERM == rxvt* ]] || [[ "$TERM_PROGRAM" == "iTerm.app" ]]; then
+ print -Pn "\e]2;$2:q\a" #set window name
+ print -Pn "\e]1;$1:q\a" #set icon (=tab) name (will override window name on broken terminal)
+ fi
+}
+
+ZSH_THEME_TERM_TAB_TITLE_IDLE="%15<..<%~%<<" #15 char left truncated PWD
+ZSH_THEME_TERM_TITLE_IDLE="%n@%m: %~"
+
+#Appears when you have the prompt
+function precmd {
+ title $ZSH_THEME_TERM_TAB_TITLE_IDLE $ZSH_THEME_TERM_TITLE_IDLE
+}
+
+#Appears at the beginning of (and during) of command execution
+function preexec {
+ emulate -L zsh
+ setopt extended_glob
+ local CMD=${1[(wr)^(*=*|sudo|ssh|-*)]} #cmd name only, or if this is sudo or ssh, the next cmd
+ title "$CMD" "%100>...>$2%<<"
+}
diff --git a/lib/appearance.zsh b/lib/theme-and-appearance.zsh
index ffee52b5e..aec67721a 100644
--- a/lib/appearance.zsh
+++ b/lib/theme-and-appearance.zsh
@@ -34,5 +34,3 @@ ZSH_THEME_GIT_PROMPT_CLEAN="" # Text to display if the branch is c
# Setup the prompt with pretty colors
setopt prompt_subst
-# Load the theme
-source "$ZSH/themes/$ZSH_THEME.zsh-theme" \ No newline at end of file